﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebHierarchicalDataGrid1.DataSource = GetData();
        this.WebHierarchicalDataGrid1.DataBind();
    }

    #region Creating DataSet

    public DataSet GetData()
    {
        DataSet ds = new DataSet("Set");
        ds.Tables.Add(GetParentData());
        //ds.Tables.Add(GetChildData1());
        //ds.Tables.Add(GetChildData2());
        //ds.Relations.Add(
        //    ds.Tables["ParentTable"].Columns["Claim Number"],
        //    ds.Tables["ChildTable"].Columns["Claim Number"]);
        //ds.Relations.Add(
        //    ds.Tables["ChildTable"].Columns["DCN"],
        //    ds.Tables["ChildTable2"].Columns["DCN"]);
        return ds;
    }

    public DataTable GetParentData()
    {
        DataTable table = new DataTable("ParentTable");
        table.Columns.Add("Claim Number", typeof(string));
        table.Columns.Add("Patient Last Name", typeof(string));
        table.Columns.Add("Patient First Name", typeof(string));
        table.Columns.Add("SSN", typeof(string));
        table.Columns.Add("Injury Date", typeof(DateTime));
        table.Columns.Add("Value", typeof(int));
        for (int i = 0; i < 10; i++)
        {
           table.Rows.Add("CLM12345678" + i, "Sear", "Pat", "123456789", DateTime.Now.AddDays(-1000), 10 % (i + 1));
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["Claim Number"] };
        return table;
    }

    public DataTable GetChildData1()
    {
        DataTable table = new DataTable("ChildTable");
        table.Columns.Add("DCN", typeof(string));
        table.Columns.Add("Claim Number", typeof(string));
        table.Columns.Add("Value", typeof(int));
        table.Columns.Add("Service Date", typeof(DateTime));
        table.Columns.Add("Reject Code", typeof(string));
        table.Columns.Add("Internal Control Number", typeof(string));
        table.Columns.Add("FTIN", typeof(string));
        table.Columns.Add("Provider Name", typeof(string));
        table.Columns.Add("OCT Status", typeof(string));
        table.Columns.Add("Bill Review Status", typeof(string));
        for (int i = 0; i < 2; i++)
        {
            for (int j = 0; j < 3; j++)
            {
                table.Rows.Add("DCN12345678" + i + j, "CLM12345678" + i, i+j, DateTime.Now.AddDays(-999), "", "26070950599400", "488403658", "MCCARROLL JR H RELTON", "", "Get Status");
            }
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["DCN"] };
        return table;
    }

    public DataTable GetChildData2()
    {
        DataTable table = new DataTable("ChildTable2");
        table.Columns.Add("Pages", typeof(string));
        table.Columns.Add("DCN", typeof(string));
        for (int j = 0; j < 3; j++)
        {
            for (int k = 0; k < 2; k++)
            {
                if (k == 0)
                {
                    table.Rows.Add("MEDICAL BILL - CMS-1500, UB...", "DCN12345678" + k + j);
                    table.Rows.Add("FH EOR", "DCN12345678" + k + j);
                }
                else
                {
                    table.Rows.Add("MEDICAL BILL - CMS-1500, UB...", "DCN12345678" + k + j);
                    table.Rows.Add("FH EOR", "DCN12345678" + k + j);
                }
            }
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["Pages"], table.Columns["DCN"] };
        return table;
    }
    #endregion
    protected void WebHierarchicalDataGrid1_GroupedRowInitialized(object sender, GroupedRowEventArgs e)
    {
       ContainerGrid grid = sender as ContainerGrid;
       foreach (GroupedRecord groupedRow in grid.GroupedRows)
       {
          SetGroupText(groupedRow, e);
       }
    }

    protected void SetGroupText(GroupedRecord groupedRow, GroupedRowEventArgs e)
    {
       decimal valTotal = 0;
       int valRowCount = 0;
       groupedRow.Rows.Reset();
       while (groupedRow.Rows.MoveNext())
       {
          ContainerGridRecord row = (ContainerGridRecord)groupedRow.Rows.Current;
          Infragistics.Web.UI.Framework.Data.DataSetNode node = row.DataItem as Infragistics.Web.UI.Framework.Data.DataSetNode;
          valTotal += (int)((System.Data.DataRowView)node.Item).Row.ItemArray[5];
          valRowCount++;
          //GroupedRecordCollection grc = groupedRow.ChildGroupRows;
          //if (groupedRow.ChildGroupRows.Count > 0)
          //{
          //   foreach (GroupedRecord groupedChildRow in groupedRow.ChildGroupRows)
          //   {
          //      SetGroupText(groupedChildRow, e);
          //   }
          //}
       }       
       groupedRow.Text = "  Count: " + valRowCount.ToString() + "  Total value from Column \"Value\": " + valTotal;
    }
    protected void WebHierarchicalDataGrid1_GroupedColumnsChanging(object sender, GroupedColumnsChangingEventArgs e)
    {

    }
}